<template>
<div class="middle-box text-center loginscreen animated fadeInDown">
    <div>
        <div>
            <h1 class="logo-name" style="font-size: 75px;">NAVCON</h1>
        </div>

        <h3>Login</h3>
        <p  v-if="!loading">Please login to start!</p>
        <p v-else>Please wait!</p>
        
        <div class="sk-spinner sk-spinner-wave" v-if="loading">
            <div class="sk-rect1"></div>
            <div class="sk-rect2"></div>
            <div class="sk-rect3"></div>
            <div class="sk-rect4"></div>
            <div class="sk-rect5"></div>
        </div>

        <div v-else>
            <div>
                <div class="m-t has-error" v-if="form_errors.message">
                    <span class="help-block">
                        * {{ form_errors.message }}
                    </span>
                </div>
            </div>


            <div class="m-t">
                <div class="form-group" v-bind:class="{ 'has-error': form_errors.email  }">
                    <input type="email" 
                            class="form-control" 
                            v-model="email"
                            autofocus
                            placeholder="Email" 
                    >

                    <div class="pull-left" v-if="form_errors.email">
                        <span class="help-block has-error" v-for="error in form_errors.email" :key="error.id">
                            * {{ error }}
                        </span>
                    </div>
                </div>

                <div class="form-group" v-bind:class="{ 'has-error': form_errors.password  }">
                    <input type="password" 
                            class="form-control" 
                            v-model="password"
                            placeholder="Password" >

                    <div class="pull-left" v-if="form_errors.password">
                        <span class="help-block  has-error" v-for="error in form_errors.password" :key="error.id">
                            * {{ error }}
                        </span>
                    </div>
                </div>

                <div class="row">
                    <!--
                    <div class="col-xs-7">
                        <div class="form-group pull-left">
                            <div class="checkbox i-checks">
                                <label>
                                    <input type="checkbox" 
                                            name="remember"> 
                                    Remember me?
                                </label>
                            </div>
                        </div>
                    </div>
                    -->

                    <div class="col-xs-12 pull-right">
                        <div class="form-group">
                            <button v-on:click="login()" 
                                    class="btn btn-primary block full-width m-b disable"
                                    v-bind:class="{ 'disable': loading  }"
                            >
                                Login
                            </button>
                        </div>
                    </div>
                        
                    <!--
                    <div class="col-xs-6">
                        <a class="btn btn-white btn-block" href=" route('login.employee') ">
                            Log as employee
                        </a>
                    </div>

                    <div class="col-xs-6">
                        <a class="btn btn-white btn-block" href=" route('login.student') ">
                            Log as student
                        </a>
                    </div>
                    -->
                </div>
            </div>
        </div>
        
        <p class="m-t">
            {{ $store.state.app_name }} 
            <br>
            &copy; 2018
        </p>
    </div>
</div>
</template>

<script>
import { mapGetters } from 'vuex'

export default {
    data () {
      return {
        email: '',
        password: '',
        form_errors: [],
        loading: false
      }
    },
    methods: {
        login: async function() {
            this.loading = true

            this.form_errors = []

            let credentials = {
                email: this.email, 
                password: this.password
            }

            await this.$store.dispatch('login', credentials).then((data) => {
                if ( data.error ) {
                    this.loading = false
                    this.form_errors = data.error
                }
            })
        }
    },
    watch: {
        email() {
            this.form_errors = []
        },
        password() {
            this.form_errors = []
        }
    },
    created () {
        $('body').addClass('gray-bg')
    }
}
</script>